package es.bisite.wilssc.Activities;


import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.IntentFilter;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Point;
import android.graphics.PointF;
import android.media.Ringtone;
import android.media.RingtoneManager;
import android.net.Uri;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.os.Vibrator;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnTouchListener;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.Toast;

import com.example.bluepin.R;

import es.bisite.wilssc.BluePinImageView;
import es.bisite.wilssc.Common;
import es.bisite.wilssc.PositionRead;
import es.bisite.wilssc.Wifi.WifiRead;
import es.bisite.wilssc.Wifi.WifiReceiver;
import es.bisite.wilssc.Wifi.WifiScaner;

//===============================================
public class ConfigureActivity extends Activity 
//===============================================
{
	//++++++++++++++++++++++++++++++++++++++++++++++++++++
	
	private Button startButton; 
	private Button setButton;
	private Button stepButton;
	private CheckBox lockCheckBox;

    private BluePinImageView mapImage; //Image View con scroll y zoom
	
    private float scaleFactor; //Factor de escalado de la imagen dependiendo de la pantalla
    
    private Bitmap bluePin; //Imagen de la chincheta
    private Bitmap map;	    //Imagen del mapa
    
    private WifiManager  wifiCon;  //Manager de las conexiones Wifi 	
    private WifiReceiver wReceiver;//Receptor de las señales wifi
    private WifiScaner   wScaner;  //Lanza los escaneos Wifi
    private Thread wifiScanThread; //Hilo que lanza los escaneos wifi
    private File wFile;
    private File sFile;   
    private boolean scaning=false;
   
    private List<Long> stepList;

	//++++++++++++++++++++++++++++++++++++++++++++++++++++
	 //==========================================================
	 public final Handler playSound = new Handler()
	 //==========================================================
	  {
	    	//==========================================================
	    	@Override
	    	public void handleMessage(Message msg)
	    	//==========================================================
	    	{
				try {
			        Uri notification = RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);
			        Ringtone r = RingtoneManager.getRingtone(getApplicationContext(), notification);
			        r.play();
			        Vibrator vib = (Vibrator) getSystemService(Context.VIBRATOR_SERVICE);
			        vib.vibrate(500);
			        Toast.makeText(getApplicationContext(), "Step", Toast.LENGTH_SHORT).show();
			    } catch (Exception e) {}
	    	}
	  };
	    
	//===============================================
    @Override
    public void onCreate(Bundle savedInstanceState) 
  //===============================================
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
        this.Initialize();
    }
    
    //===============================================
    @Override
    public void  onPause() 
  //===============================================
    {
    	if(scaning==true)
    	{
    		wScaner.terminate();
    		unregisterReceiver(wReceiver);
    	}
    	super.onPause();
    }
    
    //===============================================
    private void loadSave()
    //===============================================
    {
    	//Se abre el fichero donde se almacenan los puntos configurados anterioremente, si el fichero existe se cargan
    	//dichos puntos

		try 
		{
			if(sFile.exists())
			{
				FileInputStream fstream = new FileInputStream(sFile);
				DataInputStream in = new DataInputStream(fstream);
				BufferedReader br = new BufferedReader(new InputStreamReader(in));
				String strLine;
					  
				 while ((strLine = br.readLine()) != null)   
				 {
					 String[] temp;
					 String delimiter = ";";
					 temp = strLine.split(delimiter);
					 this.mapImage.addMidPoint(new Point(Integer.parseInt(temp[0]),Integer.parseInt(temp[1])));
				 }

				 in.close();

			}
			else
			{
				sFile.createNewFile();
			}
		} 
		catch (IOException e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

    }
    
   //===============================================
    @Override
    public void  onWindowFocusChanged(boolean hasFocus) 
  //===============================================
    {
        super.onWindowFocusChanged(hasFocus);
        
        //Se calcula el factor de escalado de la pantalla
		if(map.getHeight()<map.getWidth())
		{
			scaleFactor=(float)map.getWidth()/mapImage.getWidth();
		}
		else
		{
			scaleFactor=(float)map.getWidth()/mapImage.getWidth();
		}
		
        setButton.setEnabled(true);

		mapImage.setScaleFactor(scaleFactor);
		mapImage.setPinBitmap(bluePin);
		mapImage.setPinPosition(new Point(mapImage.getWidth()/2,mapImage.getHeight()/2));
    	this.setButton.setEnabled(false);
    }
    
    //===============================================
    protected void Initialize()
    //===============================================
    {

    	this.lockCheckBox=(CheckBox)this.findViewById(R.id.checkBoxLock);
    	this.startButton = (Button)this.findViewById(R.id.buttonStart);
    	this.setButton = (Button)this.findViewById(R.id.buttonSet);
    	this.stepButton = (Button)this.findViewById(R.id.buttonStep);
    	
    	this.mapImage=(BluePinImageView)this.findViewById(R.id.image);
    	this.mapImage.setDrawingCacheEnabled(true);
    	
    	this.startButton.setEnabled(true);
    	this.setButton.setEnabled(false);
    	this.stepButton.setEnabled(false);
    	
		this.map = BitmapFactory.decodeResource(getResources(), R.drawable.fisicas);
		this.mapImage.setImageBitmap( this.map, false, null, 5.0f );
		
		if(this.map.getHeight()>this.map.getWidth())
			this.mapImage.setMinZoom(this.map.getHeight()/(float)this.map.getWidth());
		else
			this.mapImage.setMinZoom(this.map.getWidth()/(float)this.map.getHeight());
		
		this.bluePin = BitmapFactory.decodeResource(getResources(), R.drawable.bluepin);
		
        this.wifiCon = (WifiManager) getSystemService(Context.WIFI_SERVICE);  
        this.stepList=new ArrayList<Long>();       
        
        //GSM
        //this.gsmManager = (TelephonyManager)getSystemService(Context.TELEPHONY_SERVICE);
        
		//Apertura del fichero de escaneos wifi
    	wFile=new File( Environment.getExternalStorageDirectory()+Common.FOLDER_PATH+Common.READINGS_FILE);
    	sFile=new File(Environment.getExternalStorageDirectory()+Common.FOLDER_PATH+Common.POINTS_FILE);
    	
    	//Si el fichero de escaneos existe se pregunta si se quiere sobreescribir el contenido o continuar mapeando
    	if(wFile.exists())
    	{
    		AlertDialog.Builder builder = new AlertDialog.Builder(this);
    		builder.setMessage("�Desea sobreescribirlo?");
    		builder.setTitle("El fichero de mapeado ya existe");
    		builder.setCancelable(false);
    		builder.setNegativeButton("No",new DialogInterface.OnClickListener() 
    		{
    			 //===============================================
    		     public void onClick(DialogInterface dialog, int id) 
    		     //===============================================
    		     {
    		    	 loadSave();
    		  
    		    	 dialog.cancel();
    		      
    		     }
    		});
    		builder.setPositiveButton("Si",new DialogInterface.OnClickListener() 
    		{
    			 //===============================================
    	         public void onClick(DialogInterface dialog, int id) 
    	         //===============================================
    	         {
    	     		    wFile.delete();
    	     		    sFile.delete();
    	        		try 
    	        		{
							wFile.createNewFile();
							sFile.createNewFile();

						} 
    	        		catch (IOException e) 
    	        		{
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
    		     }
    		 });
    		
    		AlertDialog alert = builder.create();
    		alert.show();
    
    	}
    	//Si el fichero no existe se crea
    	else
    	{
    		try 
    		{
    			wFile.createNewFile();
    			sFile.createNewFile();
			} catch (IOException e) 
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
    	}
    	
		
		//===============================================
		this.mapImage.setOnTouchListener(new OnTouchListener() 
		//===============================================
		{
			//===============================================
			public boolean onTouch(View v, MotionEvent event)
			//===============================================
			{
				//Si la funcion de bloqueo esta activada se coloca la chincheta en donde se ha pulsado
				if(lockCheckBox.isChecked()==true)
				{
					mapImage.setPinPosition(new Point((int)event.getX() ,(int)(event.getY()-50)));
					mapImage.invalidate();
				}
				//Si la funcion de bloqueo no esta activada se llama a la clase que hereda de ImageView
				//y que gestiona el scroll y zoom
				else
				{
					mapImage.onTouchSuper(event);
				}
				
				return true;
			}
		});

    	//===============================================
    	 this.startButton.setOnClickListener(new OnClickListener() 
    	//===============================================
    	 {   
    		   //===============================================
    		    public void onClick(View v) 
    		    //===============================================
    		    {
              
    		    	//Si el boton se encuentra en estado de START
    		    	if(startButton.getText()==getResources().getString(R.string.start))
    				{
    		    		scaning=true;
    		    		//Registro de los servicios y escuchadores para las se�ales wifi y GSM
    		    	    wScaner=new WifiScaner(wifiCon);
    		         	wifiScanThread= new Thread(wScaner);
    		    		wifiScanThread.start();
                        mapImage.Reset();
    		            wReceiver = new WifiReceiver(wifiCon,wScaner,playSound);
    		         	registerReceiver(wReceiver, new IntentFilter(WifiManager.SCAN_RESULTS_AVAILABLE_ACTION));    
    		            
    		    		setButton.setEnabled(true);
    		        	stepButton.setEnabled(true);
    		        	
    		        	//Inicializacion del mapa
        		    	PointF nuevo= new PointF(mapImage.getPinPosition().x,mapImage.getPinPosition().y);
    		            startButton.setText(getResources().getString(R.string.end));
    		            stepList=new ArrayList<Long>();
    		            
    		            mapImage.addPoint(PositionRead.ScreenToMap(nuevo, mapImage.getScale(),mapImage.getScrollRect(),scaleFactor),System.currentTimeMillis());
    		            
    				}
    				else
    				{
    					scaning=false;		
    					//Se a�ade un nuevo punto en la posicion de la chincheta
        		    	PointF nuevo= new PointF(mapImage.getPinPosition().x,mapImage.getPinPosition().y);
        		    	long time=System.currentTimeMillis();
                        mapImage.addPoint(PositionRead.ScreenToMap(nuevo, mapImage.getScale(),mapImage.getScrollRect(),scaleFactor),time);
                        stepList.add(Long.valueOf(time));
                        mapImage.invalidate();
                        
    					startButton.setText(getResources().getString(R.string.start));
    					stepButton.setEnabled(false);
    					setButton.setEnabled(false);
    					
    					//Se deshabilitan la recepci�n de Wifi y GSM
    					wScaner.terminate();
    			       	unregisterReceiver(wReceiver);
    			       	
    			      	List<PositionRead> points = mapImage.getPoints();  //Puntos sobre el mapa
    			       	List<WifiRead> wReads     = wReceiver.getScans();  //Lecturas Wifi
    			       	
    			       	PositionRead pIni; //Punto inicial del segmento
    			       	PositionRead pFin; //Punto final del segmento

    			       	int wCounter=0; //Contador para la lista de lecturas Wifi
    			        int sCounter=0; //Contador para la lista de lecturas de pasos
    			        int gCounter=0; //Contador para la lista de lecturas GSM
    			        
    			        	try 
    			        	{

    			            	FileWriter wFW=new FileWriter(wFile,true);
    			               	FileWriter sFW = new FileWriter(sFile,true);

    			        		for(int i=0;i<points.size()-1;i++)
    			        		{
    			        			pIni=points.get(i);
    			        			pFin=points.get(i+1);
    			              			            
    			        			List<WifiRead> segmentWifiRead = new ArrayList<WifiRead>(); 
    			        			List<Long>  segmentSteps    = new ArrayList<Long>();	
    			            
    			        			while(wCounter<wReads.size() && wReads.get(wCounter).getTime()>=pIni.getTime()&& wReads.get(wCounter).getTime()<=pFin.getTime())
    			        			{
    			        				segmentWifiRead.add(wReads.get(wCounter));
    			        				wCounter++;
    			        			}

    			        			while(sCounter<stepList.size() && stepList.get(sCounter)>=pIni.getTime()&& stepList.get(sCounter)<=pFin.getTime())
    			        			{
    			        				segmentSteps.add(stepList.get(sCounter));
    			        				sCounter++;
    			        			}	    

    			        			PointF vec=new PointF(pIni.getPosition().x-pFin.getPosition().x,pIni.getPosition().y-pFin.getPosition().y);
    			        			float modulo=(float) Math.sqrt(vec.x*vec.x+vec.y*vec.y);
    			        			vec.set(vec.x/modulo, vec.y/modulo);
    			        			float longV=modulo/(segmentSteps.size());
    			        			vec.set(vec.x*longV,vec.y*longV);
    			       			   
    			        			PointF lastPoint=new PointF(pIni.getPosition().x,pIni.getPosition().y);
    			            
    			        			for(int j=0;j<segmentSteps.size();j++)
    			        			{		        		
    			        				if(i==0 && j==0)
    			        				{
    			        					int initialSize=segmentWifiRead.size();
    			        					PointF aux=new PointF(lastPoint.x,lastPoint.y);
    			        					mapImage.addMidPoint(new Point((int)aux.x,(int)aux.y));
    			        					lastPoint.set(aux.x, aux.y);			
    			        					sFW.write((int)aux.x+";"+(int)aux.y+"\n");
    			           					
    			        					while(segmentWifiRead.size() > initialSize/2 && segmentWifiRead.get(0).getTime()<=segmentSteps.get(j))
    			        					{

    			        						Point act  = new Point((int)lastPoint.x,(int)lastPoint.y); 				   
    			        						Integer xVal = Integer.valueOf(act.x);
    			        						Integer yVal = Integer.valueOf(act.y);
    			        						
    			        						wFW.write( xVal+";"+yVal+";");
    			        						
    			        						List<ScanResult> lecturas = segmentWifiRead.get(0).getScans();
    			        						
    			        						for(ScanResult l:lecturas)
    			        						{
    			        							if(l.SSID==null || l.SSID=="")
    			        								wFW.write("NOSSID;" + l.BSSID +";"+l.level+";");
    			        							else
    			        								wFW.write(l.SSID +";" + l.BSSID +";"+l.level+";");
    			        						}
    			        				
    			        						wFW.write("\n");
    			        						segmentWifiRead.remove(0);   	
    			        					}
    			        					        				
    			        					aux=new PointF(lastPoint.x-vec.x,lastPoint.y-vec.y);
    			        					mapImage.addMidPoint(new Point((int)aux.x,(int)aux.y));
    			        					lastPoint.set(aux.x, aux.y);			       			
    			        					sFW.write((int)aux.x+";"+(int)aux.y+"\n");
    			        					
    			        					while(segmentWifiRead.size() >0 && segmentWifiRead.get(0).getTime()<=segmentSteps.get(j))
    			        					{

    			        						Point act  = new Point((int)lastPoint.x,(int)lastPoint.y); 			
    			        						Integer xVal = Integer.valueOf(act.x);
    			        						Integer yVal = Integer.valueOf(act.y);
    			        						wFW.write( xVal+";"+yVal+";");
    			        						List<ScanResult> lecturas = segmentWifiRead.get(0).getScans();
    			        						
    			        						for(ScanResult l:lecturas)
    			        						{
    			        							if(l.SSID==null || l.SSID=="")
    			        								wFW.write("NOSSID;" + l.BSSID +";"+l.level+";");
    			        							else
    			        								wFW.write(l.SSID +";" + l.BSSID +";"+l.level+";");
    			        						}
    			        				
    			        						wFW.write("\n");
    			        						segmentWifiRead.remove(0);   	
    			        					}
    			        					
    			        				}
    			        				else
    			        				{	        				
    			        					PointF aux=new PointF(lastPoint.x-vec.x,lastPoint.y-vec.y);
    			        					mapImage.addMidPoint(new Point((int)aux.x,(int)aux.y));
    			        					lastPoint.set(aux.x, aux.y);			       			
    			        					sFW.write((int)aux.x+";"+(int)aux.y+"\n");

    			        					while(segmentWifiRead.size() >0 && segmentWifiRead.get(0).getTime()<=segmentSteps.get(j))
    			        					{

    			        						Point act  = new Point((int)lastPoint.x,(int)lastPoint.y); 				   
    			        						Integer xVal = Integer.valueOf(act.x);
    			        						Integer yVal = Integer.valueOf(act.y);
    			        						wFW.write( xVal+";"+yVal+";");
    			        						List<ScanResult> lecturas = segmentWifiRead.get(0).getScans();
    			        						
    			        						for(ScanResult l:lecturas)
    			        						{
    			        							if(l.SSID==null || l.SSID=="")
    			        								wFW.write("NOSSID;" + l.BSSID +";"+l.level+";");
    			        								
    			        							else
    			        								wFW.write(l.SSID +";" + l.BSSID +";"+l.level+";");
    			        						}
    			        				
    			        						wFW.write("\n");
    			        						segmentWifiRead.remove(0);   	
    			        					}
    			        			
    			        				}
    			        			}
    			        		}

    			        		wFW.flush();
    			        		wFW.close();
    			        		sFW.flush();
    			        		sFW.close();
    			        		
    			        		File clasfFile =new File(Environment.getExternalStorageDirectory()+Common.FOLDER_PATH+Common.CLASF_FILE);
        			        	
    			        		if(clasfFile.exists())
    			        		{
    			        			clasfFile.delete();
    			        		}
    			        		mapImage.invalidate();	
    			        		
    						}
    			        	catch (Exception e1) 
    			        	{
    			        		e1.printStackTrace();
    			        	} 
    			        }
    				}
    		    
    		    
    	});
    	 

    	//===============================================
    	 this.stepButton.setOnClickListener(new OnClickListener() 
    	//===============================================
    	 {   
    		    public void onClick(View v) 
    		    {
                     stepList.add(Long.valueOf(System.currentTimeMillis()));
            
    		    }
    	});
    	 
    	//===============================================
    	 this.setButton.setOnClickListener(new OnClickListener() 
    	//===============================================
    	 {   
    		    public void onClick(View v) 
    		    {
                     PointF nuevo= new PointF(mapImage.getPinPosition().x,mapImage.getPinPosition().y);
                     long time =Long.valueOf(System.currentTimeMillis());
                     stepList.add(time);
                     mapImage.addPoint(PositionRead.ScreenToMap(nuevo, mapImage.getScale(),mapImage.getScrollRect(),scaleFactor),time);
                     mapImage.invalidate();
            
    		    }
    	});
    	 

    	    
    	 //===============================================
    	 this.lockCheckBox.setOnCheckedChangeListener(new OnCheckedChangeListener()
    	 //===============================================
    	 {
    		    //===============================================
    		    public void onCheckedChanged(CompoundButton buttonView, boolean isChecked)
    		    //===============================================
    		    {
    		        if ( isChecked )
    		        {
    		        	mapImage.setScrollEnabled(false);
    		        	mapImage.setScaleEnabled(false);
    		        	mapImage.setDoubleTapEnabled(false);
    		        }
    		        else
    		        {
    		        	mapImage.setScrollEnabled(true);
    		        	mapImage.setScaleEnabled(true);
    		        	mapImage.setDoubleTapEnabled(true);
    		        }

    		    }
    		});
    	 
    	 mapImage.invalidate();
    }
    

}
