package es.bisite.wilssc.Activities;

import android.app.Activity;
import android.content.Context;
import android.content.IntentFilter;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.view.Menu;

import com.example.bluepin.R;

import es.bisite.wilssc.BluePinImageView;
import es.bisite.wilssc.Wifi.WifiScaner;
import es.bisite.wilssc.WifiRem.WifiReceiverRem;

public class LocateRemActivity extends Activity 
{

		//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		 private WifiManager  wifiCon;  		//Manager de las conexiones Wifi 	
		 private WifiReceiverRem wReceiver;		//Receptor de las seales wifi
		 private WifiScaner   wScaner;  		//Lanza los escaneos Wifi
		 private Thread wifiScanThread; 		//Hilo que lanza los escaneos wifi
		 private BluePinImageView mapImage; 	//Image View con scroll y zoom
		 private Bitmap map;
		 
		 //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

		//============================================================
		@Override
		protected void onCreate(Bundle savedInstanceState) 
		//============================================================
		{
			super.onCreate(savedInstanceState);
			setContentView(R.layout.activity_locate);
			
	    	this.mapImage=(BluePinImageView)this.findViewById(R.id.image);
	    	this.mapImage.setDrawingCacheEnabled(true);
			
			this.mapImage.setImageBitmap(BitmapFactory.decodeResource(getResources(),R.drawable.intro));
		}

		//=================================================
	    @Override
	    public void onResume() 
	    //=================================================
	    {
	    	super.onResume();
	    	
		    this.wifiCon = (WifiManager) getSystemService(Context.WIFI_SERVICE);  
		    
	 	    wScaner=new WifiScaner(wifiCon);
	      	wifiScanThread= new Thread(wScaner);
	 		wifiScanThread.start();
	        wReceiver = new WifiReceiverRem(wifiCon,wScaner,this.mapImage,this.getApplicationContext());
	      	registerReceiver(wReceiver, new IntentFilter(WifiManager.SCAN_RESULTS_AVAILABLE_ACTION));    
	    }
	    
	    //===============================================
	    @Override
	    public void  onPause() 
	  //===============================================
	    {
	    
	    	wScaner.terminate();
	       	unregisterReceiver(wReceiver);

	    	super.onPause();
	    }
	    
	    //===============================================
	    @Override
	    public void  onWindowFocusChanged(boolean hasFocus) 
	  //===============================================
	    {
	        super.onWindowFocusChanged(hasFocus);
	    }
	    
		//============================================================
		@Override
		public boolean onCreateOptionsMenu(Menu menu) 
		//============================================================
		{
			// Inflate the menu; this adds items to the action bar if it is present.
			getMenuInflater().inflate(R.menu.locate_rem, menu);
			return true;
		}

	}