package es.bisite.wilssc.GSM;

import java.util.ArrayList;
import java.util.List;


import android.app.Activity;
import android.content.Context;
import android.telephony.NeighboringCellInfo;
import android.telephony.PhoneStateListener;
import android.telephony.SignalStrength;
import android.telephony.TelephonyManager;
import android.telephony.gsm.GsmCellLocation;

//==================================================================
public class GSMListener extends PhoneStateListener 
//==================================================================
{
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	private List<GSMRead> gsmReads;
	TelephonyManager gsmManager;
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	
	//==================================================================
	public GSMListener(TelephonyManager man)
	//==================================================================
	{
		this.gsmManager=man;
		this.gsmReads=new ArrayList<GSMRead>();
	}
	
	
	//http://forums.overclockers.co.uk/showthread.php?p=19235374
	//==================================================================
	@Override
	public void onSignalStrengthsChanged(SignalStrength signalStrength)
	//==================================================================
	{
		if(signalStrength==null ||this.gsmManager==null)
		{
			return;
		}
		GSMRead lectura;
		GSMScan actual;
		
		int dBm = -113 + 2 * signalStrength.getGsmSignalStrength();
       
        GsmCellLocation cellLocation = (GsmCellLocation)this.gsmManager.getCellLocation();
        
        if(cellLocation==null) return;
        int lac = cellLocation.getLac();  
        int cid = cellLocation.getCid();
       
        actual=new GSMScan(lac,cid,dBm);

        List<NeighboringCellInfo> neighboringList = this.gsmManager.getNeighboringCellInfo();
 
        List<GSMScan> vecinas=new ArrayList<GSMScan>();
      
        for(int i=0; i < neighboringList.size(); i++)
        {
    	    int rssi = neighboringList.get(i).getRssi();
    	    if(rssi == NeighboringCellInfo.UNKNOWN_RSSI)
    	    {
    		    dBm = 0;
    	    }
    	    else
    	    {
    		    dBm = getRssiVecinos(rssi);
    	    }
    	    vecinas.add(new GSMScan(neighboringList.get(i).getLac(),neighboringList.get(i).getCid(),dBm));
        }
        
        this.gsmReads.add(new GSMRead(System.currentTimeMillis(),actual,vecinas));
	 }
	
	//el RSSI que almacenas
	//==================================================================
	public int getRssiVecinos(int valor)
	//==================================================================
	{
		switch(this.gsmManager.getNetworkType())
		{
			 case TelephonyManager.NETWORK_TYPE_EDGE:
			 case TelephonyManager.NETWORK_TYPE_GPRS:
				 return -113 + 2 * valor;
			 default:
				 return valor -116;
					 
		}
	}
	
	//==================================================================
	public int getLocationVecinos(NeighboringCellInfo neighboringCellInfo)
	//==================================================================
	{
		 switch(this.gsmManager.getNetworkType())
		 {
			 case TelephonyManager.NETWORK_TYPE_EDGE:
			 case TelephonyManager.NETWORK_TYPE_GPRS:
				 return neighboringCellInfo.getLac();
			 default:
				 return neighboringCellInfo.getPsc();
					 
		 }
	}
	
	//==================================================================
	public List<GSMRead> getReads()
	//==================================================================
	{
		return this.gsmReads;
	}
}
