package es.bisite.wilssc;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ConnectException;
import java.net.HttpURLConnection;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketTimeoutException;
import java.net.URL;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.BasicResponseHandler;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.json.JSONException;
import org.json.JSONObject;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Point;
import android.os.AsyncTask;
import android.os.Environment;
import android.provider.Settings.Secure;
import android.util.Log;
import es.bisite.wilssc.WifiRem.WifiReceiverRem;


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
public class SendLocationTask extends AsyncTask<Void, Integer, ConnectionStatus> 
//=======================================================================
{
	 private Double lat;
	 private Double lng;
	 private String _mes;
	 private BluePinImageView mapImage;
	 private int xpos;
	 private int ypos;
	 private Context context;
	 private Bitmap map=null;
	 private WifiReceiverRem receiver;
	 
	 public  int lastMap=0;
	 public  int newMap=0; 
	 //=======================================================================
	 public SendLocationTask(String mes, BluePinImageView map,Context con,WifiReceiverRem rec) 
	//=======================================================================
	 {
		 this._mes=mes;
		 this.mapImage=map;
		 this.context=con;
		 this.lastMap=0;
		 this.newMap=0; 
		 this.receiver=rec;
		 this.lastMap=rec.getLastMap();
	 }
	
	//=======================================================================
	protected void onPreExecute() 
	//=======================================================================
	{

	}
			
	//=======================================================================
	 protected ConnectionStatus doInBackground(Void... urls) 
	//=======================================================================
	 {
		 Socket locateSocket=null;;
		 PrintWriter outStr = null;
		 BufferedReader  inStr = null;
 	     ConnectionStatus value =ConnectionStatus.SUCCESS;   

 	     String android_id = Secure.getString(context.getContentResolver(),Secure.ANDROID_ID);
 	     
 	     try 
		 {
			 locateSocket = new Socket();
			 locateSocket.connect(new InetSocketAddress("servidor.bisite.es", 4444), 1000);
			 outStr = new PrintWriter(locateSocket.getOutputStream());
			 inStr=new BufferedReader(new InputStreamReader(locateSocket.getInputStream()));
			 locateSocket.setSoTimeout(1000);
			 
			 Log.d("SendLocationTask", "enviar a servidor");
			 
		  	 System.out.println(this._mes);
			 outStr.println(this._mes);
	         outStr.flush();
			 String message = "";
	         int charsRead = 0;
	         char[] buffer = new char[1024];

	         Log.d("SendLocationTask", "leer servidor");
	         /*
	         while ((charsRead = inStr.read(buffer)) != -1) 
	         {
	                message += new String(buffer).substring(0, charsRead);
	         }
	         */
	         message=inStr.readLine();
	         
	         String[] aux;
	         aux=message.split(";");
	         String mapId=aux[0];
	         xpos=Integer.parseInt(aux[1]);
	         ypos=Integer.parseInt(aux[2]);
			 
	         outStr.close();
			 inStr.close();
			 locateSocket.close();
			 
			 Log.d("SendLocationTask", "enviar posición web");
			 
	         HttpParams httpParameters = new BasicHttpParams();
		     HttpConnectionParams.setConnectionTimeout(httpParameters, 1500);
		     HttpConnectionParams.setSoTimeout(httpParameters, 1500);
		     HttpClient httpclient = new DefaultHttpClient(httpParameters);
	 	     HttpPost httppost = new HttpPost(Common.USER_WS);

	         List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(5);
	         nameValuePairs.add(new BasicNameValuePair("action","insertLocationTerm"));
	         nameValuePairs.add(new BasicNameValuePair("user",android_id));
	         nameValuePairs.add(new BasicNameValuePair("x", String.valueOf(aux[1])));
	         nameValuePairs.add(new BasicNameValuePair("y", String.valueOf(aux[2])));
	         nameValuePairs.add(new BasicNameValuePair("map", mapId));
			 httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));

			 ResponseHandler<String> responseHandler=new BasicResponseHandler();
			 String responseBody = httpclient.execute(httppost, responseHandler);
			 JSONObject response=new JSONObject(responseBody);
	         Boolean res= response.getBoolean("result");
	         
	     	//Descarga del mapa
   	         
   	         newMap=Integer.parseInt(mapId);
   	         
   	         File file = new File(Environment.getExternalStorageDirectory().toString()+Common.IMG_PATHS+"/"+mapId+".png");
   	         
   	         if(file.exists()) 
   	         {
	             this.map=BitmapFactory.decodeFile(Environment.getExternalStorageDirectory().toString()+Common.IMG_PATHS+"/"+mapId+".png");
   	         }
   	         else
   	         {   
   	        	 File folder = new File(Environment.getExternalStorageDirectory().toString()+Common.IMG_PATHS);
   	        
   	        	  if(folder.exists()==false)
   	        	  {
   	        	 	 folder.mkdirs();
   	        	  }
   	        	
        	 	 String host=Common.IMG_SERV+"/"+mapId+"/map.png";
    	    	 URL url = new URL(host);

    	    	 HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
    	    
				 urlConnection.setRequestMethod("GET");
    	    	 urlConnection.setDoOutput(true); 
    	    	 urlConnection.setConnectTimeout(3000);
    	    	 urlConnection.setReadTimeout(3000);
    	       	 urlConnection.connect();
    	    	
    	    	 
    	    	 String filename= mapId+".png";   
    	    	 File filef = new File(folder,filename);
    	    	 if(filef.createNewFile())
    	         {
    	    		 filef.createNewFile();
    	    	 }

    	    	 FileOutputStream fileOutput = new FileOutputStream(file);
    	    	 InputStream inputStream = urlConnection.getInputStream();
    	    		
    	    	 int totalSize = urlConnection.getContentLength();
    	    	 int downloadedSize = 0;

    	    	 byte[] bufferf = new byte[1024];
    	    	 int bufferLength = 0; 

    	    	 while ( (bufferLength = inputStream.read(bufferf)) > 0 ) 
    	    	 {
    	    		 fileOutput.write(bufferf, 0, bufferLength);
    	    		 downloadedSize += bufferLength;
    	    	 }

    	    	 fileOutput.close();

	             
	             if(lastMap!=newMap)this.map=BitmapFactory.decodeFile(Environment.getExternalStorageDirectory().toString()+Common.IMG_PATHS+"/"+mapId+".png");
   	        		
   	         }
	         if(res==true)
	         {
        		 value=ConnectionStatus.SUCCESS;
	         }

			    
		 }
 		 catch (ConnectException e)  
		 {
				e.printStackTrace();
				value=ConnectionStatus.OTHERS;
		 } 
		 catch (UnknownHostException e)  
		 {
				e.printStackTrace();
				value=ConnectionStatus.OTHERS;
		 } 
		 catch (JSONException e) 
		 {
    		 e.printStackTrace();
 			 value=ConnectionStatus.JSONERROR;
    	 }
		 catch (SocketTimeoutException e) 
		 {
			 outStr.close();
			 
			 try 
			 {
				locateSocket.close();
				inStr.close();
			 } 
			 catch (IOException e1) 
			 {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			  }
	
    		 e.printStackTrace();
 			 value=ConnectionStatus.OTHERS;
    	 }
    	 catch (ClientProtocolException e) 
    	 {
    		 e.printStackTrace();
 			 value=ConnectionStatus.TIMEOUT;
    	 }
		 catch (IOException e) 
		 {
    		 e.printStackTrace();
 			 value=ConnectionStatus.HTTPERROR;
    	 }

		 finally
		 {
				 return value;
		 }
	 }

	
	 //=======================================================================
     protected void onPostExecute(ConnectionStatus value) 
	  //=======================================================================
     {
    	 switch(value)
    	 {
    	 	//+++++++++++++++++++
    	 	case SUCCESS:
    	   	//+++++++++++++++++++
    	 	{
    	 		 if(lastMap!=newMap)
    	 		 {
    	 	        float scaleFactor;
    		        
    		        //Se calcula el factor de escalado de la pantalla
    				if(map.getHeight()<map.getWidth())
    				{
    					mapImage.setScaleFactor((float)map.getWidth()/mapImage.getWidth());
    				}
    				else
    				{
    					mapImage.setScaleFactor((float)map.getWidth()/mapImage.getWidth());
    				}

    				
    	 			 mapImage.setImageBitmap(this.map);
    	 		 }
    	 		 
    	 		 this.receiver.setLastMap(newMap);
    	 		 mapImage.setUserPoint(new Point(xpos,ypos));
    	 		 mapImage.invalidate();
    	 		 
    	 		 break;
    	 	}
    	  	 default:
    	  	 {
    	  		newMap=-1;
    	  		lastMap=-1;
    	  	 }

    	 }    
  
		     
      }

	
		    
}

