package es.bisite.wilssc.WifiRem;

import java.io.IOException;
import java.net.SocketTimeoutException;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiManager;
import android.provider.Settings.Secure;
import android.util.Log;
import es.bisite.wilssc.BluePinImageView;
import es.bisite.wilssc.SendLocationTask;
import es.bisite.wilssc.Wifi.WifiRead;
import es.bisite.wilssc.Wifi.WifiScaner;

//=========================================================
public class WifiReceiverRem extends BroadcastReceiver 
//=========================================================
{
	private WifiManager wifiCon; 
    private WifiScaner  wifiScan;
    private List<WifiRead> wifiReads;
    private BluePinImageView mapImage;
    private Context context;
    private int lastMap=0;
    
	//=========================================================
	public WifiReceiverRem(WifiManager wifi,WifiScaner wifis,BluePinImageView map,Context con) 
	//=========================================================
	{
		super();
		this.wifiCon  = wifi;
		this.wifiScan = wifis;
		this.wifiReads= new ArrayList<WifiRead>();
		this.mapImage=map;
		this.context=con;
	}

	
	//=========================================================
	public List<WifiRead> getScans()
	//=========================================================
	{
		return this.wifiReads;
	}
	
	//=========================================================
	public void setLastMap(int mp)
	//=========================================================
	{
		this.lastMap=mp;
	}
	
	//=========================================================
	public int getLastMap()
	//=========================================================
	{
		return this.lastMap;
	}
	
	//=========================================================
	@Override
	public void onReceive(Context c, Intent intent)
	//=========================================================
	{

		List<ScanResult> signals = wifiCon.getScanResults();
			
		synchronized(this.wifiScan)
		{	
			String user=Secure.getString(context.getContentResolver(),Secure.ANDROID_ID);
			String headr=user+";0;test;0;411;706;-1";
			String res=headr;
		
			for(int i=0;i<signals.size();i++)
			{
				res=res+";";
				if(signals.get(i).SSID==null || signals.get(i).SSID=="")
					res+="NOSSID;";
				else
					res+=signals.get(i).SSID+";";
			
				res+=signals.get(i).BSSID+";"+signals.get(i).level;
			}

			SendLocationTask lt=new SendLocationTask(res,this.mapImage,this.context,this);
			lt.execute();

			this.wifiScan.notify();
		}
			
		
	}

}